float dist_IR_1; // переменная для хранения вычисленного расстояния 1 IR датчика расстояния
float dist_IR_2; // переменная для хранения вычисленного расстояния 2 IR датчика расстояния

int piezoPin = 3; //Пин, к которому подключен пьезодинамик.
int svet = 2; //Пин для управления светодиодной лентой
int led_1 = 4;
int led_2 = 5; //Пины для управления сигнальными светодиодами
#define IR_1 A0 // Пины для управления  IR датчиками расстояния
#define IR_2 A1
#define pin_night A2 // пин для управления датчиком освещенности
#define PIN_TRIG_1 6 // пины для управления ультразвуковыми датчиками
#define PIN_ECHO_1 7
#define PIN_TRIG_2 9
#define PIN_ECHO_2 8

long duration1, cm1, duration2, cm2; // переменные для работы ультразвуковых датчиков
int Distans_avto = 20; //допустимое раастояние до грузовика от моста
int night=100; //пороговое значение датчика света для определения ночи
 
void setup() {
 Serial.begin(9600);
 
 pinMode(piezoPin, OUTPUT);
 pinMode(svet, OUTPUT);
 pinMode(led_1, OUTPUT);
 pinMode(led_2, OUTPUT);
 pinMode(PIN_TRIG_1, OUTPUT);
 pinMode(PIN_TRIG_2, OUTPUT);
 pinMode(PIN_ECHO_1, INPUT);
 pinMode(PIN_ECHO_2, INPUT);
}

void loop() {
 Sonars();
 if ((cm1<Distans_avto & cm1>10)  || (cm2<Distans_avto & cm2>10)) //если расстояние от большегоруза до моста меньше заданного
 {
  trevoga();  // включаем тревогу
 } else { // если грузовиков нет
  if (analogRead(pin_night)<night){ // проверяем уровень света и если ночь, то
    night_Peshehod(); // проверяем наличие пешеходов
    Serial.print("Расстояние до пешехода 1: ");
    Serial.print(dist_IR_1);
    Serial.println(" см.");
    Serial.print("Расстояние до пешехода 2: ");
    Serial.print(dist_IR_2);
    Serial.println(" см.");
    if (dist_IR_1<30 || dist_IR_2<30){ // если пешеходы есть
      digitalWrite(svet,HIGH); //включаем свет в тоннеле
      delay (3000); // время для прохода по тоннелю
      } else {   // если пешеходов нет
        digitalWrite(svet,LOW); //свет выключаем
      }
  }else {   // если день
     digitalWrite(svet,LOW); //свет выключаем
   }
 }
} 



void trevoga(){
/*Функция принимает три аргумента
    1) Номер пина
    2) Частоту в герцах, определяющую высоту звука
    3) Длительность в миллисекундах. 
  */
  tone(piezoPin, 1000, 300); // Звук прекратится через 500 мс, о программа останавливаться не будет!
  digitalWrite(led_1, HIGH);
  digitalWrite(led_2, HIGH);// включение сигнальных светодиодов
  delay(300);                       // время свечения сигнальных светодиодов
  digitalWrite(led_1, LOW);
  digitalWrite(led_2, LOW);// выключение сигнальных светодиодов
  delay(300);                       // время, в течение которого сигнальные светодиоды не работают
}

void night_Peshehod() {
  float Summ_1 = 0;// переменные для нахождения суммы значения показаний IR датчиков расстояния
  float Summ_2 = 0;
  int K=30;
 for (int i=0; i<K; i++) {
    // считываем значение сенсора, а затем показания датчиков из диапазона от 1 до 1023 переводи в диапазон от 0 до 50, суммируем их, назодя среднее занчение
    int measur_1 = analogRead(IR_1);
    int measur_2 = analogRead(IR_2);
    Summ_1=Summ_1+map(measur_1,0,1023,0,50);
    Summ_2=Summ_2+map(measur_2,0,1023,0,50);
    delay(10);}
  dist_IR_1=50-(Summ_1/K);// средние значения показаний IR датчиков расстояния
  dist_IR_2=50-(Summ_2/K);   
}

void Sonars(){
// Сначала генерируем короткий импульс для первого датчика длительностью 2-5 микросекунд.

  digitalWrite(PIN_TRIG_1, LOW);
  delayMicroseconds(5);
  digitalWrite(PIN_TRIG_1, HIGH);

  // Выставив высокий уровень сигнала, ждем около 10 микросекунд. В этот момент датчик будет посылать сигналы с частотой 40 КГц.
  delayMicroseconds(10);
  digitalWrite(PIN_TRIG_1, LOW);

  //  Время задержки акустического сигнала на эхолокаторе.
  duration1 = pulseIn(PIN_ECHO_1, HIGH);

   // Преобразовываем время в расстояние
  cm1 = (duration1 / 2) / 29.1;
    if (cm1==0){
    cm1=Distans_avto+1;
  }
  // Генерируем короткий импульс для 2 датчика длительностью 2-5 микросекунд.

  digitalWrite(PIN_TRIG_2, LOW);
  delayMicroseconds(5);
  digitalWrite(PIN_TRIG_2, HIGH);

  // Выставив высокий уровень сигнала, ждем около 10 микросекунд. В этот момент датчик будет посылать сигналы с частотой 40 КГц.
  delayMicroseconds(10);
  digitalWrite(PIN_TRIG_2, LOW);

  //  Время задержки акустического сигнала на эхолокаторе.
  duration2 = pulseIn(PIN_ECHO_2, HIGH);

   //Теперь осталось преобразовать время в расстояние
  cm2 = (duration2 / 2) / 29.1;
  if (cm2==0){
    cm2=Distans_avto+1;
  }
  delay(250);
}
